Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4752)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4753)
@@ -1,20 +1,19 @@
 !> @file multi_agent_system_mod.f90
-!--------------------------------------------------------------------------------!
-! This file is part of PALM-4U.
-!
-! PALM-4U is free software: you can redistribute it and/or modify it under the 
-! terms of the GNU General Public License as published by the Free Software 
-! Foundation, either version 3 of the License, or (at your option) any later 
-! version.
-!
-! PALM-4U is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+!--------------------------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 2016-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -25,45 +24,47 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4623 2020-07-24 08:42:02Z raasch
 ! some switches calculated explicitly to avoid compiler warnings
-! 
+!
 ! 4481 2020-03-31 18:55:54Z maronga
 ! bugfix: cpp-directives for serial mode added
-! 
+!
 ! 4346 2019-12-18 11:55:56Z motisi
-! Removed wall_flags_static_0 from USE statements as it's not used within
-! the module
-! 
+! Removed wall_flags_static_0 from USE statements as it's not used within the module
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4307 2019-11-26 14:12:36Z maronga
 ! Activated output of iPT
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 3987 2019-05-22 09:52:13Z kanani
 ! Introduce alternative switch for debug output during timestepping
-! 
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction  of additional debug
+! messages
+!
 ! 3876 2019-04-08 18:41:49Z knoop
-! replaced nspec by nvar: only variable species should bconsidered, fixed species are not relevant 
-! 
+! replaced nspec by nvar: only variable species should bconsidered, fixed species are not relevant
+!
 ! 3766 2019-02-26 16:23:41Z raasch
 ! save attribute added to local targets to avoid outlive pointer target warning
-! 
+!
 ! 3665 2019-01-10 08:28:24Z raasch
 ! unused variables removed
-! 
+!
 ! 3159 2018-07-20 11:20:01Z sward
 ! Initial revision
 !
-! 
+!
 !
 ! Authors:
@@ -74,33 +75,31 @@
 ! Description:
 ! ------------
-!> Multi Agent System for the simulation of pedestrian movement in urban
-!> environments
-!------------------------------------------------------------------------------!
+!> Multi Agent System for the simulation of pedestrian movement in urban environments
+!--------------------------------------------------------------------------------------------------!
  MODULE multi_agent_system_mod
 
     USE, INTRINSIC ::  ISO_C_BINDING
 
-    USE basic_constants_and_equations_mod,                                     &
+    USE basic_constants_and_equations_mod,                                                         &
         ONLY:  pi
 
-    USE control_parameters,                                                    &
-        ONLY:  biometeorology,                                                 &
-               debug_output_timestep,                                          &
-               dt_3d,                                                          &
-               dt_write_agent_data,                                            &
-               message_string,                                                 &
+    USE control_parameters,                                                                        &
+        ONLY:  biometeorology,                                                                     &
+               debug_output_timestep,                                                              &
+               dt_3d,                                                                              &
+               dt_write_agent_data,                                                                &
+               message_string,                                                                     &
                time_since_reference_point
 
-    USE cpulog,                                                                &
+    USE cpulog,                                                                                    &
         ONLY:  cpu_log, log_point, log_point_s
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  ddx, ddy, dx, dy
 
-    USE indices,                                                               &
-        ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,        &
-               topo_top_ind
-               
-    USE random_function_mod,                                                   &
+    USE indices,                                                                                   &
+        ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb, topo_top_ind
+
+    USE random_function_mod,                                                                       &
         ONLY:  random_function
 
@@ -108,8 +107,14 @@
 
     USE pegrid
+
+    INTEGER(iwp), PARAMETER ::  max_number_of_agent_groups = 100  !< maximum allowed number of agent groups
+    INTEGER(iwp), PARAMETER ::  nr_2_direction_move = 10000       !< parameter for agent exchange
+    INTEGER(iwp), PARAMETER ::  phase_init    = 1                 !< phase parameter
+    INTEGER(iwp), PARAMETER ::  phase_release = 2                 !< phase parameter
 
     CHARACTER(LEN=15) ::  bc_mas_lr = 'absorb'  !< left/right boundary condition
     CHARACTER(LEN=15) ::  bc_mas_ns = 'absorb'  !< north/south boundary condition
 
+    INTEGER(iwp) ::  agt_path_size = 15                !< size of agent path array
     INTEGER(iwp) ::  deleted_agents = 0                !< number of deleted agents per time step
     INTEGER(iwp) ::  dim_size_agtnum_manual = 9999999  !< namelist parameter (see documentation)
@@ -133,13 +138,6 @@
     INTEGER(iwp) ::  number_of_agent_groups = 1        !< namelist parameter (see documentation)
     INTEGER(iwp) ::  sort_count_mas = 0                !< counter for sorting agents
-    INTEGER(iwp) ::  agt_path_size = 15                !< size of agent path array
     INTEGER(iwp) ::  step_dealloc_mas = 100            !< namelist parameter (see documentation)
     INTEGER(iwp) ::  total_number_of_agents            !< total number of agents in the whole model domain
-
-    INTEGER(iwp), PARAMETER ::  NR_2_direction_move = 10000 !< parameter for agent exchange
-    INTEGER(iwp), PARAMETER ::  PHASE_INIT    = 1           !< phase parameter
-    INTEGER(iwp), PARAMETER ::  PHASE_RELEASE = 2           !< phase parameter
-
-    INTEGER(iwp), PARAMETER ::  max_number_of_agent_groups = 100 !< maximum allowed number of agent groups
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  agt_count         !< 3d array of number of agents of every grid box
@@ -147,5 +145,6 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  top_top_s         !< k-index of first s-gridpoint above topography
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  top_top_w         !< k-index of first v-gridpoint above topography
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  obstacle_flags    !< flags to identify corners and edges of topography that cannot be crossed by agents
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  obstacle_flags    !< flags to identify corners and edges of topography that cannot
+                                                                    !< be crossed by agents
 
     LOGICAL ::  deallocate_memory_mas = .TRUE.          !< namelist parameter (see documentation)
@@ -245,13 +244,14 @@
     END TYPE agent_type
 
+    TYPE(agent_type)                        ::  zero_agent           !< zero agent to avoid weird thing
+
     TYPE(agent_type), DIMENSION(:), POINTER ::  agents               !< Agent array for this grid cell
-    TYPE(agent_type)                        ::  zero_agent           !< zero agent to avoid weird thing
 #if defined( __parallel )
-    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  move_also_north  !< for agent exchange between PEs
-    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  move_also_south  !< for agent exchange between PEs
     TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  agt_gh_l         !< ghost layer left of pe domain
     TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  agt_gh_n         !< ghost layer north of pe domain
     TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  agt_gh_r         !< ghost layer right of pe domain
     TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  agt_gh_s         !< ghost layer south of pe domain
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  move_also_north  !< for agent exchange between PEs
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  move_also_south  !< for agent exchange between PEs
 #endif
 !
@@ -338,16 +338,16 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Multi Agent System:
 !> executes a number of agents sub-timesteps until the model timestep is reached.
-!> The agent timestep is usually smaller than the model timestep
-!------------------------------------------------------------------------------!
+!> The agent timestep is usually smaller than the model timestep.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE multi_agent_system
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_calc_ipt,                                                   &
-               bio_calculate_mrt_grid,                                         &
+    USE biometeorology_mod,                                                                        &
+        ONLY:  bio_calc_ipt,                                                                       &
+               bio_calculate_mrt_grid,                                                             &
                bio_get_thermal_index_input_ij
 
@@ -362,11 +362,12 @@
     INTEGER(iwp)       ::  js                 !< counter
     INTEGER(iwp), SAVE ::  mas_count = 0      !< counts the mas-calls
-    INTEGER(iwp)                :: a     !< agent iterator
-    !-- local meteorological conditions
-    REAL(wp)                    :: tmrt  !< mean radiant temperature        (degree_C)
-    REAL(wp)                    :: ta    !< air temperature                 (degree_C)
-    REAL(wp)                    :: vp    !< vapour pressure                 (hPa)
-    REAL(wp)                    :: v     !< wind speed    (local level)     (m/s)
-    REAL(wp)                    :: pair  !< air pressure                    (hPa)
+    INTEGER(iwp)       ::  a                  !< agent iterator
+!
+!-- local meteorological conditions
+    REAL(wp) ::  pair  !< air pressure                    (hPa)
+    REAL(wp) ::  ta    !< air temperature                 (degree_C)
+    REAL(wp) ::  tmrt  !< mean radiant temperature        (degree_C)
+    REAL(wp) ::  v     !< wind speed    (local level)     (m/s)
+    REAL(wp) ::  vp    !< vapour pressure                 (hPa)
 
 
@@ -379,6 +380,6 @@
     CALL cpu_log( log_point(9), 'mas', 'start' )
 !
-!-- Initialize variables for the next (sub-) timestep, i.e., for marking
-!-- those agents to be deleted after the timestep
+!-- Initialize variables for the next (sub-) timestep, i.e., for marking those agents to be deleted
+!-- after the timestep
     deleted_agents = 0
     agent_substep_time = 0.0_wp
@@ -387,8 +388,7 @@
     IF ( time_arel >= dt_arel  .AND.  end_time_arel > time_since_reference_point )  THEN
 
-       CALL mas_create_agent(PHASE_RELEASE)
-!
-!--    The MOD function allows for changes in the output interval with
-!--    restart runs.
+       CALL mas_create_agent( phase_release )
+!
+!--    The MOD function allows for changes in the output interval with restart runs.
        time_arel = MOD( time_arel, MAX( dt_arel, dt_3d ) )
 
@@ -402,7 +402,7 @@
 !
 !-- Timestep loop for agent transport.
-!-- This loop has to be repeated until the transport time of every agent
-!-- (within the total domain!) has reached the LES timestep (dt_3d).
-!-- Timestep scheme is Euler-forward
+!-- This loop has to be repeated until the transport time of every agent (within the total domain!)
+!-- has reached the LES timestep (dt_3d).
+!-- Timestep scheme is Euler-forward.
     DO
 !
@@ -415,5 +415,5 @@
           CALL mas_data_output_agents ( first_call )
 #else
-          WRITE( message_string, * ) 'NetCDF is needed for agent output. ',    &
+          WRITE( message_string, * ) 'NetCDF is needed for agent output. ',                        &
                                      'Set __netcdf in compiler options'
           CALL message( 'multi_agent_system', 'PA0071', 1, 2, 0, 6, 0 )
@@ -423,6 +423,6 @@
        ENDIF
 !
-!--    Flag is true by default, will be set to false if an agent has not yet
-!--    reached the model timestep
+!--    Flag is true by default, will be set to false if an agent has not yet reached the model
+!--    timestep.
        grid_agents(:,:)%time_loop_done = .TRUE.
 
@@ -466,14 +466,13 @@
              agents(1:number_of_agents)%agent_mask = .TRUE.
 !
-!--          Initialize the variable storing the total time that an agent
-!--          has advanced within the timestep procedure
+!--          Initialize the variable storing the total time that an agent has advanced within the
+!--          timestep procedure.
              IF ( first_loop_stride )  THEN
                 agents(1:number_of_agents)%dt_sum = 0.0_wp
              ENDIF
 !
-!--          Initialize the switch used for the loop exit condition checked
-!--          at the end of this loop. If at least one agent has failed to
-!--          reach the LES timestep, this switch will be set false in 
-!--          mas_transport.
+!--          Initialize the switch used for the loop exit condition checked at the end of this loop.
+!--          If at least one agent has failed to reach the LES timestep, this switch will be set
+!--          false in mas_transport.
              dt_3d_reached_l_mas = .TRUE.
 !
@@ -481,14 +480,13 @@
              CALL mas_timestep
 !
-!--          Delete agents that have been simulated longer than allowed
+!--          Delete agents that have been simulated longer than allowed.
              CALL mas_boundary_conds( 'max_sim_time' )
 !
-!--          Delete agents that have reached target area
+!--          Delete agents that have reached target area.
              CALL mas_boundary_conds( 'target_area' )
 !
-!---         If not all agents of the actual grid cell have reached the 
-!--          LES timestep, this cell has to to another loop iteration. Due to
-!--          the fact that agents can move into neighboring grid cell, 
-!--          these neighbor cells also have to perform another loop iteration
+!--          If not all agents of the actual grid cell have reached the LES timestep, this cell has
+!--          to do another loop iteration. Due to the fact that agents can move into neighboring
+!--          grid cell, these neighbor cells also have to perform another loop iteration.
              IF ( .NOT. dt_3d_reached_l_mas )  THEN
                 js = MAX(nys,j-1)
@@ -504,11 +502,11 @@
 
 !
-!--    Find out, if all agents on every PE have completed the LES timestep
-!--    and set the switch corespondingly
+!--    Find out, if all agents on each PE have completed the LES timestep and set the switch
+!--    corespondingly.
        dt_3d_reached_l_mas = ALL(grid_agents(:,:)%time_loop_done)
 #if defined( __parallel )
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( dt_3d_reached_l_mas, dt_3d_reached_mas, 1, MPI_LOGICAL, &
-                           MPI_LAND, comm2d, ierr )
+       CALL MPI_ALLREDUCE( dt_3d_reached_l_mas, dt_3d_reached_mas, 1, MPI_LOGICAL,  MPI_LAND,      &
+                           comm2d, ierr )
 #else
        dt_3d_reached_mas = dt_3d_reached_l_mas
@@ -527,11 +525,10 @@
        CALL mas_eh_exchange_horiz
 !
-!--    Pack agents (eliminate those marked for deletion),
-!--    determine new number of agents
+!--    Pack agents (eliminate those marked for deletion), determine new number of agents
        CALL mas_ps_sort_in_subboxes
        CALL cpu_log( log_point_s(18), 'mas_move_exch_sort', 'stop' )
 !
-!--    Initialize variables for the next (sub-) timestep, i.e., for marking
-!--    those agents to be deleted after the timestep
+!--    Initialize variables for the next (sub-) timestep, i.e., for marking those agents to be
+!--    deleted after the timestep
        deleted_agents = 0
 
@@ -556,6 +553,5 @@
 !
 !--             Determine local meteorological conditions
-                CALL bio_get_thermal_index_input_ij ( .FALSE., i, j, ta, vp,  &
-                                                      v, pair, tmrt )
+                CALL bio_get_thermal_index_input_ij ( .FALSE., i, j, ta, vp, v, pair, tmrt )
 
                 DO  a = 1, number_of_agents
@@ -563,15 +559,15 @@
 !--                Calculate instationary thermal indices based on local tmrt
 
-                   CALL bio_calc_ipt ( ta, vp, v, pair, tmrt,                 &
-                                       agents(a)%dt_sum,                      &
-                                       agents(a)%energy_storage,              &
-                                       agents(a)%clothing_temp,               &
-                                       agents(a)%clo,                         &
-                                       agents(a)%actlev,                      &
-                                       agents(a)%age_years,                   &
-                                       agents(a)%weight,                      &
-                                       agents(a)%height,                      &
-                                       agents(a)%work,                        &
-                                       agents(a)%sex,                         &
+                   CALL bio_calc_ipt ( ta, vp, v, pair, tmrt,                                      &
+                                       agents(a)%dt_sum,                                           &
+                                       agents(a)%energy_storage,                                   &
+                                       agents(a)%clothing_temp,                                    &
+                                       agents(a)%clo,                                              &
+                                       agents(a)%actlev,                                           &
+                                       agents(a)%age_years,                                        &
+                                       agents(a)%weight,                                           &
+                                       agents(a)%height,                                           &
+                                       agents(a)%work,                                             &
+                                       agents(a)%sex,                                              &
                                        agents(a)%ipt )
                 END DO
@@ -602,96 +598,93 @@
  END SUBROUTINE multi_agent_system
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculation of the direction vector from each agent to its current
-!> intermittent target
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_agent_direction
-
-       IMPLICIT NONE
-
-       LOGICAL ::  path_flag !< true if new path must be calculated
-
-       INTEGER(iwp) ::  n  !< loop variable over all agents in a grid box
-       INTEGER(iwp) ::  pc !< agent path counter
-
-       REAL(wp) ::  abs_dir         !< length of direction vector (for normalization)
-!       REAL(wp) ::  d_curr_target   !< rounding influence expressed as x speed component
-!       REAL(wp) ::  d_prev_target   !< rounding influence expressed as x speed component
-       REAL(wp) ::  dir_x           !< direction of agent (x)
-       REAL(wp) ::  dir_y           !< direction of agent (y)
-!       REAL(wp) ::  dist_round = 3. !< distance at which agents start rounding a corner
-       REAL(wp) ::  dtit            !< distance to intermittent target
-!       REAL(wp) ::  round_fac  = 0.2 !< factor for rounding influence
-!       REAL(wp) ::  speed_round_x   !< rounding influence expressed as x speed component
-!       REAL(wp) ::  speed_round_y   !< rounding influence expressed as x speed component
-
-!
-!--    loop over all agents in the current grid box
-       DO n = 1, number_of_agents
-          path_flag = .FALSE.
+!> Calculation of the direction vector from each agent to its current intermittent target.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_agent_direction
+
+    IMPLICIT NONE
+
+    LOGICAL ::  path_flag  !< true if new path must be calculated
+
+    INTEGER(iwp) ::  n   !< loop variable over all agents in a grid box
+    INTEGER(iwp) ::  pc  !< agent path counter
+
+    REAL(wp) ::  abs_dir         !< length of direction vector (for normalization)
+!    REAL(wp) ::  d_curr_target   !< rounding influence expressed as x speed component
+!    REAL(wp) ::  d_prev_target   !< rounding influence expressed as x speed component
+    REAL(wp) ::  dir_x           !< direction of agent (x)
+    REAL(wp) ::  dir_y           !< direction of agent (y)
+!    REAL(wp) ::  dist_round = 3. !< distance at which agents start rounding a corner
+    REAL(wp) ::  dtit            !< distance to intermittent target
+!    REAL(wp) ::  round_fac  = 0.2 !< factor for rounding influence
+!    REAL(wp) ::  speed_round_x   !< rounding influence expressed as x speed component
+!    REAL(wp) ::  speed_round_y   !< rounding influence expressed as x speed component
+
+!
+!-- Loop over all agents in the current grid box
+    DO  n = 1, number_of_agents
+       path_flag = .FALSE.
+       pc = agents(n)%path_counter
+!
+!--    If no path was calculated for agent yet, do it.
+       IF ( pc >= 999 )  THEN
+          CALL mas_nav_find_path(n)
           pc = agents(n)%path_counter
 !
-!--       If no path was calculated for agent yet, do it
-          IF ( pc >= 999 ) THEN
+!--    Check if new path must be calculated and if so, do it.
+       ELSE
+!
+!--       Case one: Agent has come close enough to intermittent target.
+!--                 -> chose new int target and calculate rest of path if no
+!--                    new intermittent targets are left
+          dtit = SQRT(   ( agents(n)%x - agents(n)%path_x(pc) )**2                                 &
+                       + ( agents(n)%y - agents(n)%path_y(pc) )**2 )
+          IF ( dtit < dist_to_int_target )  THEN
+             agents(n)%path_counter = agents(n)%path_counter + 1
+             pc = agents(n)%path_counter
+!
+!--          Path counter out of scope (each agent can store a maximum of 15 intermittent targets on
+!--          the way to its final target); new path must be calculated.
+             IF ( pc >= SIZE( agents(n)%path_x) )  THEN
+                path_flag = .TRUE.
+             ENDIF
+!
+!--          Case two: Agent too far from path
+!--                    -> set flag for new path to be calculated
+          ELSEIF ( dist_point_to_edge(agents(n)%path_x(pc-1),                                      &
+                                      agents(n)%path_y(pc-1),                                      &
+                                      agents(n)%path_x(pc),                                        &
+                                      agents(n)%path_y(pc),                                        &
+                                      agents(n)%x, agents(n)%y)                                    &
+                   > max_dist_from_path )                                                          &
+          THEN
+             path_flag = .TRUE.
+          ENDIF
+!
+!--       If one of the above two cases was true, calculate new path and reset 0th path point.
+!--       This point (the last target the agent had) is needed for the agent's rounding of corners
+!--       and the calculation of its deviation from its current path.
+          IF ( path_flag )  THEN
              CALL mas_nav_find_path(n)
              pc = agents(n)%path_counter
-!
-!--       Check if new path must be calculated and if so, do it
-          ELSE
-!
-!--          Case one: Agent has come close enough to intermittent target.
-!--                    -> chose new int target and calculate rest of path if no
-!--                       new intermittent targets are left
-             dtit = SQRT((agents(n)%x - agents(n)%path_x(pc))**2               &
-                       + (agents(n)%y - agents(n)%path_y(pc))**2)
-             IF ( dtit < dist_to_int_target ) THEN
-                agents(n)%path_counter = agents(n)%path_counter + 1
-                pc = agents(n)%path_counter
-!
-!--             Path counter out of scope (each agent can store a maximum of 15
-!--             intermittent targets on the way to her final target); new path
-!--             must be calculated
-                IF ( pc >= SIZE(agents(n)%path_x) ) THEN
-                   path_flag = .TRUE.
-                ENDIF
-!
-!--          Case two: Agent too far from path 
-!--                    -> set flag for new path to be calculated
-             ELSEIF ( dist_point_to_edge(agents(n)%path_x(pc-1),               &
-                                         agents(n)%path_y(pc-1),               &
-                                         agents(n)%path_x(pc),                 &
-                                         agents(n)%path_y(pc),                 &
-                                         agents(n)%x, agents(n)%y)             &
-                      > max_dist_from_path )                                   &
-             THEN
-                path_flag = .TRUE.
-             ENDIF
-!
-!--          If either of the above two cases was true, calculate new path and 
-!--          reset 0th path point. This point (the last target the agent had)
-!--          is needed for the agents rounding of corners and the calculation
-!--          of her deviation from her current path
-             IF ( path_flag ) THEN
-                CALL mas_nav_find_path(n)
-                pc = agents(n)%path_counter
-             ENDIF
           ENDIF
-!
-!--       Normalize direction vector
-          abs_dir             = 1.0d-12
-          dir_x               = agents(n)%path_x(pc) - agents(n)%x
-          dir_y               = agents(n)%path_y(pc) - agents(n)%y
-          abs_dir             = SQRT(dir_x**2 + dir_y**2)+1.0d-12
-!--         needed later for corner rounding
-!           dir_x               = dir_x/abs_dir
-!           dir_y               = dir_y/abs_dir
-!           dir_x               = dir_x + speed_round_x
-!           dir_y               = dir_y + speed_round_y
-!           abs_dir             = SQRT(dir_x**2 + dir_y**2)+1.0d-12
-          agents(n)%speed_e_x = dir_x/abs_dir
-          agents(n)%speed_e_y = dir_y/abs_dir
-       ENDDO
+       ENDIF
+!
+!--    Normalize direction vector
+       abs_dir             = 1.0d-12
+       dir_x               = agents(n)%path_x(pc) - agents(n)%x
+       dir_y               = agents(n)%path_y(pc) - agents(n)%y
+       abs_dir             = SQRT( dir_x**2 + dir_y**2 )+1.0d-12
+!--      needed later for corner rounding
+!        dir_x               = dir_x/abs_dir
+!        dir_y               = dir_y/abs_dir
+!        dir_x               = dir_x + speed_round_x
+!        dir_y               = dir_y + speed_round_y
+!        abs_dir             = SQRT(dir_x**2 + dir_y**2)+1.0d-12
+       agents(n)%speed_e_x = dir_x/abs_dir
+       agents(n)%speed_e_y = dir_y/abs_dir
+    ENDDO
 
 !
@@ -702,5 +695,5 @@
 !           speed_round_x = 0.
 !           speed_round_y = 0.
-!           
+!
 !           d_curr_target = SQRT( (agents(n)%path_x(pc) - agents(n)%x)**2 +      &
 !                                 (agents(n)%path_y(pc) - agents(n)%y)**2 )
@@ -722,7 +715,7 @@
 !                              SIN( pi/dist_round*d_curr_target )
 !           ENDIF
-! 
-!           IF ( d_prev_target < dist_round ) THEN
-!              IF ( agents(n)%path_x(pc) /= agents(n)%path_x(pc+1) ) THEN
+!
+!           IF ( d_prev_target < dist_round )  THEN
+!              IF ( agents(n)%path_x(pc) /= agents(n)%path_x(pc+1) )  THEN
 !                 speed_round_x = speed_round_x +                                   &
 !                                 (agents(n)%path_x(pc) - agents(n)%path_x(pc+1)) / &
@@ -731,6 +724,6 @@
 !                                 SIN( pi/dist_round*d_prev_target )
 !              ENDIF
-!              
-!              IF ( agents(n)%path_y(pc) /= agents(n)%path_y(pc+1) ) THEN
+!
+!              IF ( agents(n)%path_y(pc) /= agents(n)%path_y(pc+1) )  THEN
 !                 speed_round_y = speed_round_y +                                   &
 !                              (agents(n)%path_y(pc) - agents(n)%path_y(pc+1)) / &
